package com.edufound.ott.zijie.yuwen.application;

import android.app.Application;
import android.content.Intent;
import android.content.IntentFilter;

import com.edufound.ott.zijie.yuwen.receiver.HomeKeyEventReceiver;
import com.edufound.ott.zijie.yuwen.receiver.NetworkChangeReceiver;
import com.edufound.ott.zijie.yuwen.util.ContextUtil;

public class MyApplication extends Application {
    //网络异常监听
    NetworkChangeReceiver mNetworkReceiver;
    //按home键的receiver
    HomeKeyEventReceiver mHomeReceiver;

    @Override
    public void onCreate() {
        super.onCreate();
        ContextUtil.setAppStartTime(System.currentTimeMillis());
        ContextUtil.setmApplicationContext(this);
        initBoardCastReceiver();
    }

    void initBoardCastReceiver() {
        mHomeReceiver = new HomeKeyEventReceiver();
        registerReceiver(mHomeReceiver, new IntentFilter(Intent.ACTION_CLOSE_SYSTEM_DIALOGS));
        mNetworkReceiver = new NetworkChangeReceiver();
        IntentFilter netFilter = new IntentFilter();
        netFilter.addAction("android.net.conn.CONNECTIVITY_CHANGE");
        registerReceiver(mNetworkReceiver, netFilter);
    }
}
