package com.edufound.ott.zijie.yuwen.base;

import android.app.Activity;
import android.content.IntentFilter;
import android.os.Bundle;

import androidx.annotation.Nullable;

import com.edufound.ott.zijie.yuwen.mvp.IModel;
import com.edufound.ott.zijie.yuwen.mvp.IView;
import com.edufound.ott.zijie.yuwen.receiver.NetworkChangeReceiver;

public class BaseActivity<M extends IModel, V extends IView, P extends BasePresenter> extends Activity implements BaseMVP<M, V, P> {


    protected P mPresenter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //创建Presenter
        mPresenter = createPresenter();
        if (mPresenter != null) {
            //将Model层注册到Presenter中
            mPresenter.registerModel(createModel());
            //将View层注册到Presenter中
            mPresenter.registerView(createView());
        }
    }



    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mPresenter != null) {
            //Activity销毁时的调用，让具体实现BasePresenter中onViewDestroy()方法做出决定
            mPresenter.destroy();
        }
    }

    @Override
    public M createModel() {
        return null;
    }

    @Override
    public V createView() {
        return null;
    }

    @Override
    public P createPresenter() {
        return null;
    }
}
