package com.edufound.ott.zijie.yuwen.mvp.model;

import android.app.Activity;
import android.os.Process;
import android.webkit.JavascriptInterface;

import com.edufound.ott.zijie.yuwen.mvp.IModel;
import com.edufound.ott.zijie.yuwen.util.ContextUtil;
import com.edufound.ott.zijie.yuwen.util.DeviceUtil;
import com.edufound.ott.zijie.yuwen.util.DeviceUuidFactory;
import com.edufound.ott.zijie.yuwen.util.SharedPerfenceUtil;

public class MainModel implements MainModelInter {
    private String LOAD_URL = "https://www.baidu.com/";
    private DeviceUtil deviceUtil;

    public MainModel() {
        deviceUtil = new DeviceUtil();
    }

    @Override
    public String getDefaultWebUrl() {
        return LOAD_URL + "?";
    }

    @Override
    public String getLoadParams(Activity activity) {
        String preuuid = SharedPerfenceUtil.getPrefString(ContextUtil.getmApplicationContext(), "", "").toString();
        if (preuuid == "") {
            preuuid = new DeviceUuidFactory(ContextUtil.getmApplicationContext()).getUuid().toString();
        }
        ContextUtil.setUuid(preuuid);
        StringBuffer params = new StringBuffer();
        params.append("&uuid=" + preuuid.toString());
        params.append("&width=" + deviceUtil.getWidth(activity));
        params.append("&height=" + deviceUtil.getHeight(activity));
        params.append("&model=" + deviceUtil.getSystemModel());
        params.append("&versionCode=" + deviceUtil.getVersionCode(activity));
        params.append("&versionName=" + deviceUtil.getVersionName(activity));
        return params.toString();
    }

}


interface MainModelInter extends IModel {
    String getDefaultWebUrl();

    String getLoadParams(Activity activity);

}