package com.edufound.ott.zijie.yuwen.util;

import android.content.Context;
import android.content.SharedPreferences;

import java.util.List;

public class SharedPerfenceUtil {

    private static final String spName = "efunbox";
    private static int model = Context.MODE_PRIVATE;

    public static String getPrefString(Context context, String key, final String defaultValue) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.getString(key, defaultValue);
    }

    public static void setPrefString(Context context, final String key, final String value) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        sp.edit().putString(key, value).commit();
    }

    public static boolean getPrefBoolean(Context context, final String key, final boolean defaultValue) {

        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.getBoolean(key, defaultValue);
    }

    public static boolean hasKey(Context context, final String key) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.contains(key);
    }

    public static void setPrefBoolean(Context context, final String key, final boolean value) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        sp.edit().putBoolean(key, value).commit();
    }

    public static void setPrefInt(Context context, final String key, final int value) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        sp.edit().putInt(key, value).commit();
    }

    public static int getPrefInt(Context context, final String key, final int defaultValue) {

        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.getInt(key, defaultValue);
    }

    public static void setPrefFloat(Context context, final String key, final float value) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        sp.edit().putFloat(key, value).commit();
    }

    public static float getPrefFloat(Context context, final String key, final float defaultValue) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.getFloat(key, defaultValue);
    }

    public static void setPrefLong(Context context, final String key, final long value) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        sp.edit().putLong(key, value).commit();
    }

    public static long getPrefLong(Context context, final String key, final long defaultValue) {
        SharedPreferences sp = context.getSharedPreferences(spName, model);
        return sp.getLong(key, defaultValue);
    }

    public static void loadRecourdsArray(Context mContext, List<String> recourds, String name) {
        SharedPreferences sp = mContext.getSharedPreferences(name, model);
        recourds.clear();
        int size = sp.getInt("recourds_size", 0);

        for (int i = 0; i < size; i++) {
            recourds.add(sp.getString("recourds_" + i, null));
        }
    }

    public static boolean saveRecourdsArray(Context context, List<String> recourds, String name) {
        SharedPreferences sp = context.getSharedPreferences(name, model);
        SharedPreferences.Editor mEdit1 = sp.edit();
        mEdit1.putInt("recourds_size", recourds.size()); /* sKey is an array */

        for (int i = 0; i < recourds.size(); i++) {
            mEdit1.remove("recourds_" + i);
            mEdit1.putString("recourds_" + i, recourds.get(i));
        }

        return mEdit1.commit();
    }

    public static void clearRecourds(Context context, String name) {
        SharedPreferences sp = context.getSharedPreferences(name, model);
        SharedPreferences.Editor mEdit1 = sp.edit();
        mEdit1.clear();
        mEdit1.commit();
    }

    public static void removeByKey(Context context, String name, String key) {
        SharedPreferences sp = context.getSharedPreferences(name, model);
        SharedPreferences.Editor mEdit1 = sp.edit();
        mEdit1.remove(key);
        mEdit1.commit();
    }
}
